// ColdDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Peltier.h"
#include "ColdDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColdDlg dialog


CColdDlg::CColdDlg(CWnd* pParent /*=NULL*/)
	: CTabPageSSL(CColdDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CColdDlg)
	m_power = 0.0f;
	m_thermal_resistance = 0.0f;
	m_cold_radio = 0;
	m_ambient_temperature = 0.0f;
	m_hot_temperature = 0.0f;
	m_messages = _T("If you are not sure what to enter here, a value of 0.1-0.2 for thermal resistance is a good guess.");
	//}}AFX_DATA_INIT
}


void CColdDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColdDlg)
	DDX_Text(pDX, IDC_POWER_CP, m_power);
	DDX_Text(pDX, IDC_RTHERM_CP, m_thermal_resistance);
	DDX_Radio(pDX, IDC_SRRADIO_CP, m_cold_radio);
	DDX_Text(pDX, IDC_TC_CP, m_ambient_temperature);
	DDX_Text(pDX, IDC_TH_CP, m_hot_temperature);
	DDX_Text(pDX, IDC_MESSAGES, m_messages);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColdDlg, CDialog)
	//{{AFX_MSG_MAP(CColdDlg)
	ON_BN_CLICKED(IDC_SRRADIO_CP, OnSrradio)
	ON_BN_CLICKED(IDC_CRRADIO_CP, OnSrradio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColdDlg message handlers

void CColdDlg::OnSrradio() 
{
	UpdateData(TRUE);

	switch(m_cold_radio)
	{

	case 0:
		GetDlgItem(IDC_RTHERM_CP) -> EnableWindow(TRUE);
		GetDlgItem(IDC_TC_CP) -> EnableWindow(FALSE);
		GetDlgItem(IDC_TH_CP) -> EnableWindow(FALSE);
		GetDlgItem(IDC_POWER_CP) -> EnableWindow(FALSE);

		GetDlgItem(IDC_RTHERM_CP) -> SetFocus();

		m_ambient_temperature = 0;
		m_hot_temperature = 0;
		m_power = 0;

		break;

	default:
		GetDlgItem(IDC_RTHERM_CP) -> EnableWindow(FALSE);
		GetDlgItem(IDC_TC_CP) -> EnableWindow(TRUE);
		GetDlgItem(IDC_TH_CP) -> EnableWindow(TRUE);
		GetDlgItem(IDC_POWER_CP) -> EnableWindow(TRUE);

		GetDlgItem(IDC_TC_CP) -> SetFocus();

		m_thermal_resistance = 0;

		break;
	}
	
	UpdateData(FALSE);
}

void CColdDlg::OnCalcr() 
{
	UpdateData(TRUE);

	if((m_power <= 0) || (m_hot_temperature < m_ambient_temperature))
	{
		m_messages = "Calculation failed. Please check that P > 0 and Th > Tamb";
		UpdateData(FALSE);
		return;
	}

	m_thermal_resistance = (m_hot_temperature - m_ambient_temperature) / m_power;

	m_messages = "Thermal resistance calculated successfully";
	
	UpdateData(FALSE);
}
