// CoolerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Peltier.h"
#include "CoolerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCoolerDlg dialog


CCoolerDlg::CCoolerDlg(CWnd* pParent /*=NULL*/)
	: CTabPageSSL(CCoolerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoolerDlg)
	m_cooler_radio = 0;
	m_power = 0.0f;
	m_thermal_resistance = 0.0f;
	m_ambient_temperature = 0.0f;
	m_hot_temperature = 0.0f;
	m_messages = _T("Typical values for thermal resistance: 0.05-0.3 for water, and 0.2-0.6 for air cooling.");
	//}}AFX_DATA_INIT
}


void CCoolerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoolerDlg)
	DDX_Radio(pDX, IDC_SRRADIO, m_cooler_radio);
	DDX_Text(pDX, IDC_POWER, m_power);
	DDX_Text(pDX, IDC_RTHERM, m_thermal_resistance);
	DDX_Text(pDX, IDC_TAMB, m_ambient_temperature);
	DDX_Text(pDX, IDC_TH, m_hot_temperature);
	DDX_Text(pDX, IDC_MESSAGES, m_messages);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCoolerDlg, CDialog)
	//{{AFX_MSG_MAP(CCoolerDlg)
	ON_BN_CLICKED(IDC_SRRADIO, OnSrradio)
	ON_BN_CLICKED(IDC_CRRADIO, OnSrradio)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoolerDlg message handlers

void CCoolerDlg::OnSrradio() 
{
	UpdateData(TRUE);

	switch(m_cooler_radio)
	{

	case 0:
		GetDlgItem(IDC_RTHERM) -> EnableWindow(TRUE);
		GetDlgItem(IDC_TAMB) -> EnableWindow(FALSE);
		GetDlgItem(IDC_TH) -> EnableWindow(FALSE);
		GetDlgItem(IDC_POWER) -> EnableWindow(FALSE);

		GetDlgItem(IDC_RTHERM) -> SetFocus();

		m_ambient_temperature = 0;
		m_hot_temperature = 0;
		m_power = 0;

		break;

	default:
		GetDlgItem(IDC_RTHERM) -> EnableWindow(FALSE);
		GetDlgItem(IDC_TAMB) -> EnableWindow(TRUE);
		GetDlgItem(IDC_TH) -> EnableWindow(TRUE);
		GetDlgItem(IDC_POWER) -> EnableWindow(TRUE);

		GetDlgItem(IDC_TAMB) -> SetFocus();

		m_thermal_resistance = 0;

		break;
	}
	
	UpdateData(FALSE);
}

void CCoolerDlg::OnCalcr() 
{
	UpdateData(TRUE);

	if((m_power <= 0) || (m_hot_temperature < m_ambient_temperature))
	{
		m_messages = "Calculation failed. Please check that P > 0 and Th > Tamb";
		return;
	}

	m_thermal_resistance = (m_hot_temperature - m_ambient_temperature) / m_power;

	m_messages = "Thermal resistance calculated successfully";
	
	UpdateData(FALSE);
}
